package com.ruoyi.system.service.impl;

import com.ruoyi.system.api.model.LoginUser;
import com.ruoyi.system.api.domain.SysUser;
import com.ruoyi.common.core.utils.ServletUtils;
import com.ruoyi.common.core.utils.DateUtils;
import com.ruoyi.common.core.utils.ip.IpUtils;
import com.ruoyi.common.core.utils.StringUtils;
import java.util.List;
import com.ruoyi.system.domain.SysBussLog;
import com.ruoyi.system.mapper.SysUserMapper;
import com.ruoyi.common.security.service.TokenService;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.system.mapper.SysBussLogMapper;
import org.springframework.stereotype.Service;
import com.ruoyi.system.service.ISysBussLogService;

@Service
public class SysBussLogServiceImpl implements ISysBussLogService
{
    @Autowired
    private SysBussLogMapper sysBussLogMapper;
    @Autowired
    private TokenService tokenService;
    @Autowired
    private SysUserMapper sysUserMapper;
    
    public SysBussLog selectSysBussLogByBussId(final Long bussId) {
        return this.sysBussLogMapper.selectSysBussLogByBussId(bussId);
    }
    
    public List<SysBussLog> selectSysBussLogList(final SysBussLog sysBussLog) {
        return this.sysBussLogMapper.selectSysBussLogList(sysBussLog);
    }
    
    public int insertSysBussLog(final Integer type, final Long targetId, String targetName, final String remark) {
        if (StringUtils.isEmpty(targetName)) {
            final SysUser user = this.sysUserMapper.selectUserById(targetId);
            targetName = user.getUserName();
        }
        final SysBussLog obj = new SysBussLog();
        obj.setType(type);
        obj.setTargetId(targetId);
        obj.setTargetName(targetName);
        obj.setRemark(remark);
        obj.setOperIp(IpUtils.getHostIp());
        obj.setOperTime(DateUtils.getNowDate());
        try {
            final LoginUser loginUser = this.tokenService.getLoginUser(ServletUtils.getRequest());
            obj.setOperId(loginUser.getUserid());
            obj.setOperName(loginUser.getUsername());
        }
        catch (final Exception ignore) {
            obj.setOperId(targetId);
            obj.setOperName(targetName);
        }
        return this.sysBussLogMapper.insertSysBussLog(obj);
    }
    
    public int updateSysBussLog(final SysBussLog sysBussLog) {
        return this.sysBussLogMapper.updateSysBussLog(sysBussLog);
    }
    
    public int deleteSysBussLogByBussIds(final Long[] bussIds) {
        return this.sysBussLogMapper.deleteSysBussLogByBussIds(bussIds);
    }
    
    public int deleteSysBussLogByBussId(final Long bussId) {
        return this.sysBussLogMapper.deleteSysBussLogByBussId(bussId);
    }
}
